
//### Sound

datablock AudioDescription(ScorpionLooping3d)
{
   volume   = 20.0;
   isLooping= true;

   is3D     = true;
   ReferenceDistance= 5.5;
   MaxDistance= 100.0;
   type     = $SimAudioType;
};
datablock AudioProfile(ScorpionSound)
{
   filename    = "./Engine.wav";
   description = ScorpionLooping3d;
   preload = true;
};

datablock AudioProfile(ScorpionFireSound)
{
  filename = "./Scorpionfire.wav";
  description = AudioDefault3d;
  preload = true;
};

datablock AudioProfile(scorpionExplodeSound)
{
  filename = "./impact.wav";
  description = AudioDefault3d;
  preload = true;
};



//### Effects


  ///New Explosion\\\
datablock ParticleData(ScorpionImpactFireParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = -1;
   inheritedVelFactor   = 1;
   constantAcceleration = 0.0;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 500;
   textureName          = "base/data/particles/cloud";
   spinSpeed		      = 10.0;
   spinRandomMin		   = -150.0;
   spinRandomMax	   	= 150.0;
   colors[0]     = "1 0.5 0 0.4";
   colors[1]     = "1 0.2 0 0.3";
   colors[2]     = "1 0 0 0";
   sizes[0]      = 0.5;
   sizes[1]      = 0.35;
   sizes[2]      = 0.25;
	useInvAlpha = false;
};
datablock ParticleEmitterData(ScorpionImpactFireEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ScorpionImpactFireParticle";
};

datablock DebrisData(ScorpionImpactDebris)
{
   emitters = "ScorpionImpactFireEmitter";

   shapeFile = "base/data/shapes/empty.dts";
   lifetime = 0.8;
   lifetimeVariance = 0.3;
   minSpinSpeed = 0;
   maxSpinSpeed = 1;
   elasticity = 0.3;
   friction = 0.2;
   numBounces = 5;
   staticOnMaxBounce = true;
   fade = true;
   gravModifier = 2;
};

datablock ParticleData(ScorpionImpactExplosionParticle)
{
   dragCoefficient		= 0.4;
   windCoefficient		= 0.0;
   gravityCoefficient	= -0.5;
   inheritedVelFactor	= 0.2;
   constantAcceleration	= 0.0;
   lifetimeMS		= 100;
   lifetimeVarianceMS	= 15;
   spinSpeed		= 10;
   spinRandomMin	= -1000.0;
   spinRandomMax	= 1000.0;
   useInvAlpha		= false;
   animateTexture	= false;
   textureName	= "base/data/particles/star1";
   colors[0]	= "1 0 0 1";
   colors[1]	= "1 1 0 0";
   sizes[0]	= 25;
   sizes[1]	= 50;
};

datablock ParticleEmitterData(ScorpionImpactExplosionEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   lifeTimeMS	   = 250;
   ejectionVelocity = 25;
   velocityVariance = 5;
   ejectionOffset   = 3;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ScorpionImpactExplosionParticle";
};

datablock ParticleData(ScorpionImpactExplosionParticle2)
{
	dragCoefficient		= 3;
	windCoefficient		= 0.5;
	gravityCoefficient	= -0.1;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2500;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	textureName	= "base/data/particles/cloud";

	colors[0]	= "1 0,1 0 0.8";
	colors[1]	= "1 0.5 0 0.6";
	colors[2]	= "1 0 0 0";
	sizes[0]	= 5;
	sizes[1]	= 3.5;
	sizes[2]	= 5;
};

datablock ParticleEmitterData(ScorpionImpactExplosionEmitter2)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifetimeMS       = 150;
   ejectionVelocity = 40;
   velocityVariance = 15;
   ejectionOffset   = 0.5;
   thetaMin         = 0;
   thetaMax         = 85;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ScorpionImpactExplosionParticle2";
};

datablock ParticleData(ScorpionImpactExplosionParticle3)
{
	dragCoefficient		= 1;
	windCoefficient		= 1;
	gravityCoefficient	= -0.35;
	inheritedVelFactor	= 0.2;
	constantAcceleration	= 0;
	lifetimeMS		= 2500;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 10;
	spinRandomMin		= -200;
	spinRandomMax		= 200;
	useInvAlpha		= false;
	animateTexture		= false;
	textureName	= "base/data/particles/cloud";

	colors[0]	= "1 0.5 0 0.8";
	colors[1]	= "1 0.75 0 0.4";
	colors[2]	= "1 1 0 0.1";
	sizes[0]	= 5;
	sizes[1]	= 3;
	sizes[2]	= 0;
	times[0]	= 0;
	times[1]	= 0.75;
	times[2]	= 1;
};

datablock ParticleEmitterData(ScorpionImpactExplosionEmitter3)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifetimeMS       = 100;
   ejectionVelocity = 13;
   velocityVariance = 10;
   ejectionOffset   = 1;
   thetaMin         = 0;
   thetaMax         = 87;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ScorpionImpactExplosionParticle3";
};

datablock ExplosionData(ScorpionImpactExplosion)
{
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
   lifeTimeMS = 150;

   particleEmitter = ScorpionImpactFireEmitter;
   particleDesnity = 300;
   particleRadius = 12;

   debris = ScorpionImpactDebris;
   debrisNum = 30;
   debrisNumVariance = 5;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 90;
   debrisVelocity = 75;
   debrisVelocityVariance = 10;

   soundProfile = ScorpionImpactExplosionSound;

   emitter[0] = ScorpionImpactExplosionEmitter;
   emitter[1] = ScorpionImpactExplosionEmitter2;
   emitter[2] = ScorpionImpactExplosionEmitter3;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "5.0 5.0 5.0";
   camShakeDuration = 1;
   camShakeRadius = 17;

   lightStartRadius = 100;
   lightEndRadius = 25;
   lightStartColor = "1 1 1";
   lightEndColor = "1 1 1";

   impulseRadius = 16;
   impulseForce = 5000;

   radiusDamage = 200;
   damageRadius = 15;
};

  ///End Explosion\\\



datablock ParticleData(tireParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.4 0.4 0.3";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 2;
  sizes[1] = 6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(tireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "tireParticle";
  useEmitterColors = true;
};

datablock ParticleData(debrisExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 4000;
  lifetimeVarianceMS = 2000;
  textureName = "base/data/particles/chunk";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.2 0.2 0.2 1";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 0.5;
  sizes[1] = 0.5;
  useInvAlpha = true;
};

datablock ParticleEmitterData(debrisExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 30;
  velocityVariance = 15;
  ejectionOffset = 5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "debrisExplosionParticle";
};

datablock ParticleData(smokeExplosionParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 5000;
  lifetimeVarianceMS = 2500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "1 0.8 0.4 1";
  colors[1] = "0.2 0.2 0.2 0.5";
  colors[2] = "0.2 0.2 0.2 0";
  sizes[0] = 60;
  sizes[1] = 15;
  sizes[2] = 30;
  times[0] = 0;
  times[1] = 0.02;
  times[2] = 1;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(smokeExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 10;
  velocityVariance = 1;
  ejectionOffset = 5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "smokeExplosionParticle";
};

datablock ExplosionData(finalExplosion)
{
  lifeTimeMS = 100;
  emitter[0] = debrisExplosionEmitter;
  emitter[1] = smokeExplosionEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  lightStartRadius = 30;
  lightEndRadius = 0;
  lightStartColor = "1 0.6 0.2";
  lightEndColor = "0 0 0";
  damageRadius = 10;
  radiusDamage = 200;
  impulseRadius = 10;
  impulseForce = 200;
  soundProfile = vehicleExplosionSound;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 60;
};

datablock ProjectileData(explosionProjectile : vehicleFinalExplosionProjectile)
{
  uiName = "";
};

datablock ProjectileData(finalExplosionProjectile : vehicleFinalExplosionProjectile)
{
  uiName = "";
  explosion = finalExplosion;
};

datablock ParticleData(bulletDebrisExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/chunk";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.2 0.2 0.2 1";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 0.2;
  sizes[1] = 0.2;
  useInvAlpha = true;
};

datablock ParticleEmitterData(bulletDebrisExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 16;
  velocityVariance = 8;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 30;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "bulletDebrisExplosionParticle";
};

datablock ParticleData(bulletExplosionSmokeParticle)
{
  dragCoefficient = 6;
  gravityCoefficient = 0.2;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1400;
  lifetimeVarianceMS = 200;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.6 0.6 0.6 1";
  colors[1] = "0.6 0.6 0.6 0.2";
  colors[2] = "0.4 0.4 0.4 0";
  sizes[0] = 0.5;
  sizes[1] = 0.6;
  sizes[2] = 5;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(bulletExplosionSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 8;
  periodVarianceMS = 0;
  ejectionVelocity = 9;
  velocityVariance = 8;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 30;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "bulletExplosionSmokeParticle";
};

datablock ParticleData(ScorpionFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "./M45Flash";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "1 1 1 1";
  colors[1] = "1 1 1 1";
  colors[2] = "1 1 1 0";
  sizes[0] = 0.2;
  sizes[1] = 5;
  sizes[2] = 1;
  times[9] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(ScorpionFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 250;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "ScorpionFlashParticle";
};

datablock ParticleData(ScorpionSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.2;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 800;
  lifetimeVarianceMS = 400;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.3 0.3 0.3 1";
  colors[1] = "0.2 0.2 0.2 0.3";
  colors[2] = "0.1 0.1 0.1 0";
  sizes[0] = 0.5;
  sizes[1] = 2;
  sizes[2] = 5;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(ScorpionSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 6;
  periodVarianceMS = 0;
  ejectionVelocity = 30;
  velocityVariance = 20;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 20;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "ScorpionSmokeParticle";
};

datablock ParticleData(ScorpionTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 2;
	gravityCoefficient	= 0.01;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 3000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;
	textureName		= "base/data/particles/dot";
	colors[0]     = "0.5 0.5 0.5 1";
	colors[1]     = "0.5 0.5 0.5 0";
	sizes[0]	= 0.4;
	sizes[1]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};
datablock ParticleEmitterData(ScorpionTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = ScorpionTrailParticle;

   useEmitterColors = true;
   uiName = "";
};

datablock ShapeBaseImageData(ScorpionFireImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "FireB";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.05;
  stateEmitter[0] = ScorpionFlashEmitter;
  stateEmitterTime[0] = 0.05;

  stateName[1] = "FireB";
  stateTransitionOnTimeout[1] = "Done";
  stateWaitForTimeout[1] = true;
  stateTimeoutValue[1] = 0.2;
  stateEmitter[1] = rocketSmokeEmitter; 
  stateEmitterTime[1] = 0.2;

  stateName[2] = "Done";
  stateScript[2] = "onDone";
};

function ScorpionFireImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock DebrisData(shellDebris)
{
  shapeFile = "./shell.dts";
  lifetime = 2;
  minSpinSpeed = -400;
  maxSpinSpeed = 200;
  elasticity = 0.5;
  friction = 0.2;
  numBounces = 3;
  staticOnMaxBounce = true;
  snapOnMaxBounce = false;
  fade = true;
  gravModifier = 2;
};

datablock ParticleData(ScorpionShellDebrisExplosionParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 4000;
  lifetimeVarianceMS = 2000;
  textureName = "base/data/particles/chunk";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.2 0.2 0.2 1";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 0.5;
  sizes[1] = 0.5;
  useInvAlpha = true;
};

datablock ParticleEmitterData(ScorpionShellDebrisExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 1;
  periodVarianceMS = 0;
  ejectionVelocity = 20;
  velocityVariance = 10;
  ejectionOffset = 2.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "ScorpionShellDebrisExplosionParticle";
};

datablock ParticleData(ScorpionShellSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 3500;
  lifetimeVarianceMS = 1500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "1 0.8 0.4 1";
  colors[1] = "0.2 0.2 0.2 0.5";
  colors[2] = "0.2 0.2 0.2 0";
  sizes[0] = 20;
  sizes[1] = 5;
  sizes[2] = 10;
  times[0] = 0;
  times[1] = 0.02;
  times[2] = 1;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(ScorpionShellSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 10;
  velocityVariance = 1;
  ejectionOffset = 2.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "ScorpionShellSmokeParticle";
};

datablock ExplosionData(ScorpionShellExplosion)
{
  lifeTimeMS = 100;
  emitter[0] = ScorpionShellDebrisExplosionEmitter;
  emitter[1] = ScorpionShellSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  lightStartRadius = 10;
  lightEndRadius = 0;
  lightStartColor = "1 0.6 0.2";
  lightEndColor = "0 0 0";
  damageRadius = 5;
  radiusDamage = 150;
  impulseRadius = 5;
  impulseForce = 300;
  soundProfile = scorpionExplodeSound;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 20;
};

//### Projectile

AddDamageType("Scorpion",'<bitmap:Add-Ons/Vehicle_Scorpion/CI_Scorpion>%1','%2<bitmap:Add-Ons/Vehicle_Scorpion/CI_Scorpion>%1',1,1);

datablock ProjectileData(ScorpionShellProjectile)
{
  uiName = "";
  projectileShapeName = "./Scorpionprojectile.dts";
  directDamage = 250;
  directDamageType = $DamageType::Scorpion;
  radiusDamageType = $DamageType::Scorpion;
  brickExplosionRadius = 5;
  brickExplosionImpact = true;
  brickExplosionForce = 100;
  brickExplosionMaxVolume = 100;
  brickExplosionMaxVolumeFloating = 100;
  impactImpulse = 200;
  particleEmitter     = "ScorpionTrailEmitter";
  explosion = ScorpionImpactExplosion;
  muzzleVelocity = 200;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 5000;
  fadeDelay = 5000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  isBallistic = true;
  gravityMod = 0.25;
  hasLight = 1;
  lightRadius = 5;
  lightColor = "1 0.5 0";
  explodeOnDeath = 1;
};


//### Turret & MG

datablock TSShapeConstructor(ScorpionturretDts)
{
  baseShape = "./ScorpionTurret.dts";
  sequence0 = "./s_root.dsq root";
  sequence1 = "./s_root.dsq run";
  sequence2 = "./s_root.dsq walk";
  sequence3 = "./s_root.dsq back";
  sequence4 = "./s_root.dsq side";
  sequence5 = "./s_root.dsq crouch";
  sequence6 = "./s_root.dsq crouchRun";
  sequence7 = "./s_root.dsq crouchBack";
  sequence8 = "./s_root.dsq crouchSide";
  sequence9 = "./s_look.dsq look";
  sequence10 = "./s_root.dsq headside";
  sequence11 = "./s_root.dsq headUp";
  sequence12 = "./s_root.dsq jump";
  sequence13 = "./s_root.dsq standjump";
  sequence14 = "./s_root.dsq fall";
  sequence15 = "./s_root.dsq land";
  sequence16 = "./s_root.dsq armAttack";
  sequence17 = "./s_root.dsq armReadyLeft";
  sequence18 = "./s_root.dsq armReadyRight";
  sequence19 = "./s_root.dsq armReadyBoth";
  sequence20 = "./s_root.dsq spearready";
  sequence21 = "./s_root.dsq spearThrow";
  sequence22 = "./s_root.dsq talk";
  sequence23 = "./s_root.dsq death1";
  sequence24 = "./s_root.dsq shiftUp";
  sequence25 = "./s_root.dsq shiftDown";
  sequence26 = "./s_root.dsq shiftAway";
  sequence27 = "./s_root.dsq shiftTo";
  sequence28 = "./s_root.dsq shiftLeft";
  sequence29 = "./s_root.dsq shiftRight";
  sequence30 = "./s_root.dsq rotCW";
  sequence31 = "./s_root.dsq rotCCW";
  sequence32 = "./s_root.dsq undo";
  sequence33 = "./s_root.dsq plant";
  sequence34 = "./s_root.dsq sit";
  sequence35 = "./s_root.dsq wrench";
};

datablock PlayerData(ScorpionTurretPlayer)
{
  renderFirstPerson = false;
  emap = false;
  className = Armor;
  shapeFile = "./Scorpionturret.dts";
  cameraMaxDist = 1;
  cameraTilt = 0.261;
  cameraVerticalOffset = 2.3;
  cameraDefaultFov = 90;
  cameraMinFov = 5;
  cameraMaxFov = 120;
  aiAvoidThis = true;
  minLookAngle = -1.5708;
  maxLookAngle = 0.5;
  maxFreelookAngle = 3;
  mass = 200000;
  drag = 1;
  density = 5;
  maxDamage = 500;
  maxEnergy = 10;
  repairRate = 0.33;
  rechargeRate = 0.4;
  runForce = 1000;
  runEnergyDrain = 0;
  minRunEnergy = 0;
  maxForwardSpeed = 0;
  maxBackwardSpeed = 0;
  maxSideSpeed = 0;
  maxForwardCrouchSpeed = 0;
  maxBackwardCrouchSpeed = 0;
  maxSideCrouchSpeed = 0;
  maxUnderwaterForwardSpeed = 0;
  maxUnderwaterBackwardSpeed = 0;
  maxUnderwaterSideSpeed = 0;
  jumpForce = 0;
  jumpEnergyDrain = 0;
  minJumpEnergy = 0;
  jumpDelay = 0;
  minJetEnergy = 0;
  jetEnergyDrain = 0;
  canJet = 0;
  minImpactSpeed = 250;
  speedDamageScale = 3.8;
  boundingBox = vectorScale("4.2 4.2 1.2",4);
  crouchBoundingBox = vectorScale("4.2 4.2 1.2",4);
  pickupRadius = 0.75;
  jetEmitter = "";
  jetGroundEmitter = "";
  jetGroundDistance = 4;
  splash = PlayerSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 0.1;
  splashEmitter[0] = PlayerFoamDropletsEmitter;
  splashEmitter[1] = PlayerFoamEmitter;
  splashEmitter[2] = PlayerBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  runSurfaceAngle = 85;
  jumpSurfaceAngle = 86;
  minJumpSpeed = 20;
  maxJumpSpeed = 30;
  horizMaxSpeed = 68;
  horizResistSpeed = 33;
  horizResistFactor = 0.35;
  upMaxSpeed = 80;
  upResistSpeed = 25;
  upResistFactor = 0.3;
  footstepSplashHeight = 0.35;
  JumpSound = "";
  groundImpactMinSpeed = 10;
  groundImpactShakeFreq = "4 4 4";
  groundImpactShakeAmp = "1 1 1";
  groundImpactShakeDuration = 0.8;
  groundImpactShakeFalloff = 10;
  maxItems = 10;
  maxWeapons = 5;
  maxTools = 5;
  uiName = "Scorpion Turret";
  rideable = true;
  lookUpLimit = 0.6;
  lookDownLimit = 0.4;
  canRide = false;
  showEnergyBar = false;
  paintable = true;
  brickImage = horseBrickImage;
  numMountPoints = 1;
  mountThread[0] = "sit";
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
  useCustomPainEffects = true;
  PainHighImage = "";
  PainMidImage = "";
  PainLowImage = "";
  painSound = "";
  deathSound = "";
};

//### Vehicle

datablock WheeledVehicleTire(ScorpionTire)
{
  shapeFile = "./emptyWheel.dts";
  mass = 10;
  radius = 1;
  staticFriction = 5;
  kineticFriction = 5;
  restitution = 0.5;
  lateralForce = 18000;
  lateralDamping = 4000;
  lateralRelaxation = 0.01;
  longitudinalForce = 14000;
  longitudinalDamping = 2000;
  longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(ScorpionSpring)
{
  length = 0.5;
  force = 6000;
  damping = 2000;
  antiSwayForce = 6;
};

datablock WheeledVehicleData(ScorpionVehicle)
{
  uiName = "M808-B Scorpion MBT";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./Scorpion.dts";
  emap = true;
  minMountDist = 3;
  numMountPoints = 3;
  mountThread[0] = "sit";
  mountThread[1] = "sit";
  mountThread[2] = "sit";
  maxDamage = 500;
  destroyedLevel = 400;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;
  massCenter = "0 0 -0.5";
  maxSteeringAngle = 0.9;
  integration = 4;
  tireEmitter = tireEmitter;
  cameraRoll = false;
  cameraMaxDist = 13;
  cameraOffset = 7.5;
  cameraLag = 0.0;
  cameraDecay = 0.75;
  cameraTilt = 0.4;
  collisionTol = 0.1;
  contactTol = 0.1;
  useEyePoint = false;
  defaultTire = ScorpionTire;
  defaultSpring = ScorpionSpring;
  numWheels = 4;
  mass = 400;
  density = 5;
  drag = 1.6;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 10;
  softImpactSpeed = 10;
  hardImpactSpeed = 15;
  groundImpactMinSpeed = 10;
  engineTorque = 5000;
  engineBrake = 500;
  brakeTorque = 5000;
  maxWheelSpeed = 25;
  rollForce = 900;
  yawForce = 600;
  pitchForce = 1000;
  rotationalDrag = 0.2;
  maxEnergy = 100;
  jetForce = 3000;
  minJetEnergy = 30;
  jetEnergyDrain = 2;
  splash = vehicleSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 1.4;
  splashEmitter[0] = vehicleFoamDropletsEmitter;
  splashEmitter[1] = vehicleFoamEmitter;
  splashEmitter[2] = vehicleBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  softImpactSound = slowImpactSound;
  hardImpactSound = fastImpactSound;
  justcollided = 0;
  rideable = true;
  lookUpLimit = 1;
  lookDownLimit = 0;
  paintable = true;
  damageEmitter[0] = VehicleBurnEmitter;
  damageEmitterOffset[0] = "0 0 0";
  damageLevelTolerance[0] = 0.99;
  damageEmitter[1] = VehicleBurnEmitter;
  damageEmitterOffset[1] = "0 0 0";
  damageLevelTolerance[1] = 1;
  numDmgEmitterAreas = 1;
  initialExplosionProjectile = explosionProjectile;
  initialExplosionOffset = 1;
  burnTime = 4000;
  finalExplosionProjectile = finalExplosionProjectile;
  finalExplosionOffset = 0.5;
  minRunOverSpeed = 4;
  runOverDamageScale = 25;
  runOverPushScale = 1.2;
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
};

//### Functions

function ScorpionVehicle::onAdd(%this,%obj)
{

  %obj.PlayAudio(0,ScorpionSound);
  
  for(%i=0;%i<%this.numWheels;%i++)
  {
    %obj.setWheelTire(%i,%this.defaultTire);
    %obj.setWheelSpring(%i,%this.defaultSpring);
  }
  %obj.setWheelSteering(0,1);
  %obj.setWheelSteering(1,1);
  %obj.setWheelSteering(4,-0.8);
  %obj.setWheelSteering(5,-0.8);
  %obj.setWheelPowered(0,true);
  %obj.setWheelPowered(1,true);
  %obj.setWheelPowered(2,true);
  %obj.setWheelPowered(3,true);
  %obj.setWheelPowered(4,true);
  %obj.setWheelPowered(5,true);
  %t = new AIPlayer() { dataBlock = ScorpionTurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,1);
  %obj.turret = %t;
  %obj.creationTime = getSimTime();
  if(%t.dataBlock !$= ScorpionTurretPlayer) return;
  if(!isObject(%t)) return;
  %parent = %t.getObjectMount();
  if(!isObject(%parent)) return;
  %t.spawnBrick = %parent.spawnBrick;
  %t.brickGroup = %parent.brickGroup;
}

function ScorpionVehicle::onRemove(%this,%obj)
{
  if(isObject(%obj.turret)) %obj.turret.delete();
}

function ScorpionTurretPlayer::onAdd(%this, %obj)
{
  %obj.lastShotTime = getSimTime() - 2000;
  parent::onAdd(%this,%obj);
}

package ScorpionPackage
{
  function Player::Burn(%obj,%time)
  {
    if(%obj.dataBlock $= ScorpionTurretPlayer) return;
    parent::Burn(%obj,%time);
  }
  function ShapeBase::setNodeColor(%obj,%node,%color)
  {
    parent::setnodecolor(%obj,%node,%color);
    if(isObject(%obj.turret)) %obj.turret.setNodeColor("ALL",%color);
  }
  function ScorpionVehicle::Damage(%this,%obj,%source,%pos,%amout,%type)
  {
    if(%amout <= 50) %amout = 0;
    if((%obj.getDamageLevel()+%amout) >= %this.maxDamage)
    {
      if(%obj.destroyed) return;
      %obj.setNodeColor("ALL","0 0 0 1");
      if(isObject(%obj.turret))
      {
        %obj.turret.delete();
        %p = new Projectile()
        {
          dataBlock = finalExplosionProjectile;
          initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
          initialVelocity = "0 0 1";
          client = %obj.lastDamageClient;
          sourceClient = %obj.lastDamageClient;
        };
        MissionCleanup.add(%p);
      }
      else
      {
        %p = new Projectile()
        {
          dataBlock = explosionProjectile;
          initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
          initialVelocity = "0 0 1";
          client = %obj.lastDamageClient;
          sourceClient = %obj.lastDamageClient;
        };
        MissionCleanup.add(%p);
      }
      if(%obj.destroyed) return;
      %obj.setDamageLevel(%this.maxDamage);
      %obj.destroyed = 1;
      %obj.schedule(%this.burnTime,"finalExplosion");
      if(isObject(%obj.spawnBrick.client.minigame)) %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
      %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
    }
    else
      parent::Damage(%this,%obj,%source,%pos,%amout,%type);
  }
  function Player::emote(%obj,%emote)
  {
    if(%obj.dataBlock $= ScorpionTurretPlayer) return;
    parent::emote(%obj,%emote);
  }
  function ScorpionTurretPlayer::onDisabled(%this,%obj,%state)
  {
    %tank = %obj.getObjectMount();
    if(isObject(%tank)) %pos = vectorAdd(%obj.getObjectMount().getPosition(),"0 0" SPC %obj.getObjectMount().dataBlock.initialExplosionOffset);
    else
      %pos = %obj.getHackPosition();
    %p = new Projectile()
    {
      dataBlock = finalExplosionProjectile;
      initialPosition = %pos;
      initialVelocity = "0 0 1";
      client = %obj.lastDamageClient;
      sourceClient = %obj.lastDamageClient;
    };
    MissionCleanup.add(%p);
    %obj.schedule(10,"delete");
    if(isObject(%tank))
    {
      %player = %obj.getMountedObject(0);
      if(isObject(%player)) %obj.getObjectMount().schedule(10,"mountObject",%player,2);
    }
    if(!isObject(%tank))
    {
      parent::onDisabled(%this,%obj,%state);
    }
  }
  function armor::onMount(%this,%obj,%col,%slot)
  {
    parent::onMount(%this,%obj,%col,%slot);
    if(isObject(%obj.client))
    {
      if(%col.getDataBlock() == ScorpionTurretPlayer.getId()) ServerCmdUnUseTool(%obj.client);
    }
  }
  function armor::onTrigger(%this,%obj,%triggerNum,%val)
  {
    %mount = %obj.getObjectMount();
    if(%obj.getDataBlock().getID() == ScorpionTurretPlayer.getID()) %mount = %obj;
    if(isObject(%mount))
    {
      if(%mount.getDataBlock() == ScorpionTurretPlayer.getId() && %triggerNum == 0 && %val)
      {
        %client = %obj.client;
        if(isObject(%client)) ServerCmdUnUseTool(%client);
        if(getSimTime() - %obj.lastShotTime < 4000) return;
        %scaleFactor = getWord(%mount.getScale(),2);
        %p = new Projectile()
        {
          dataBlock = ScorpionShellProjectile;
          initialPosition = %mount.getSlotTransform(1);
          initialVelocity = vectorScale(%mount.getMuzzleVector(1),200);
          sourceObject = %obj;
          client = %obj.client;
          sourceSlot = 0;
          originPoint = %mount.getSlotTransform(1);
        };
        MissionCleanup.add(%p);
        %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
        %mount.mountImage(ScorpionFireImage,1);
        serverPlay3D(ScorpionFireSound,%obj.getPosition());
        %tank = %mount.getObjectMount();
        if(isObject(%tank))
        {
          %theVector = %mount.getEyeVector();
          %theVector = vectorAdd(%theVector,"0 0 1");
          %theVector = vectorScale(%theVector,%tank.getDataBlock().mass);
          %theVector = vectorSub(%theVector,vectorScale(%thevector,2));
          %tank.applyImpulse(getWords(%mount.getEyeTransform(),0,2),%theVector);
        }
        %obj.lastShotTime = getSimTime();
        return;
      }
    }
    parent::onTrigger(%this,%obj,%triggerNum,%val);
  }
};
activatepackage(ScorpionPackage);
